'// ---------------------------------------------------------------------------------------------------------------------------
'// 
'// Kelly Daamen, daamen@hotmail.com
'// 
'// ---------------------------------------------------------------------------------------------------------------------------

Dim nrOfCalenderItemsToShow 
Dim nrOfTaskItemsToShow
Dim intItemLength
Dim showLocation
Dim showDateTime
Dim nrOfMail
Dim NewMailIcon
Dim InboxIcon
Dim Skin
Dim showImportantMailNr
Dim nrErrors
Dim taskCategory
Dim nrCalendarLines
Dim nrTaskLines
Dim useSearchFolder
Dim txtUnreadtext
Dim txtNoApptToday
Dim once
Dim objApp
Dim objOutlook
Dim didit

doso = 1 
'------------------------------------------------------------------------------------------------------------------------------
' Start of the gadget. Start MS Outlook or create Outlook object. 
'------------------------------------------------------------------------------------------------------------------------------
Sub SetOutlookObject
  On Error Resume next
  
  doso = System.Gadget.Settings.read("pause")
  
  If doso = "" Then 							            'gadget is running first time
    doso = 1
    s = System.Gadget.Settings.write("pause", doso)
  End if 

  If doso = 1 Then                                         'is gadget in pause mode?
    Set objApp = GetObject(, "Outlook.Application")
    If Err <> 0 Then                                       'outlook is not running what to do now?
      If didit = 0 Then
        didit = 1
        a = MsgBox("MS Outlook is not running, do you want to start it now?",vbyesno)   
        If a = 6 Then
          b = System.Shell.execute("Outlook.exe", "/recycle")
          MsgBox ("Wait until MS Outlook is started, then press OK to continue.")
          didit = 0
        Else
          Set objApp = CreateObject("Outlook.Application")
        End If 
      End If
      Err = 0
    End If  
  Else                                                     'gadget is in pause mode
    'this part is triggered after a restart of the machine 
    t = "The gadget is paused." & vbCrLf & "Doubleclick the gadget to resume"
	lblCalendar.innerText = t
	lblCalendar2.innerText = ""
	lblTasks.innerText = "- Paused -"
	lblInbox.innerText = "- Paused -"
  End If 
 
  Set objOutlook = objApp.GetNameSpace("MAPI")
 
End Sub 

'------------------------------------------------------------------------------------------------------------------------------
' Sub to initialize. create refresh intervals and get settings
'------------------------------------------------------------------------------------------------------------------------------
Sub Window_Onload
On Error Resume Next
  init
  
  'Set timers
  iTimerID1 = window.SetInterval("MailboxInfo",   30000)   ' 30 sec.
  iTimerID2 = window.SetInterval("CalendarInfo", 300000)   ' 5 min.
  iTimerID3 = window.SetInterval("TaskInfo",     300000)   ' 5 min.

  'Get Settings  
  nrOfCalenderItemsToShow = System.Gadget.Settings.read("nrCal")
  nrOfTaskItemsToShow     = System.Gadget.Settings.read("nrTask")
  showLocation            = System.Gadget.Settings.read("showLoc")
  showDateTime            = System.Gadget.Settings.read("showDT")
  SkinDocked              = System.Gadget.Settings.read("SkinDocked")
  SkinUnDocked            = System.Gadget.Settings.read("SkinUnDocked")
  showImportantMailNr     = System.Gadget.Settings.read("showImportantMailNr")
  cntSubFolder            = System.Gadget.Settings.read("cntSubFolder")
  taskCategory            = System.Gadget.Settings.read("tskFilter")
  taskImportance          = System.Gadget.Settings.read("tskImportance")
  useSearchFolder         = System.Gadget.Settings.read("useSearchFolder")
  nrOfMail                = 9999                           ' do not start with unread mail notification
  
  'Empty settings? -> fill defaults
  If nrOfCalenderItemsToShow = "" Then 
    nrOfCalenderItemsToShow = 3
  End If
  
  If nrOfTaskItemsToShow = "" Then 
    nrOfTaskItemsToShow = 3
  End If
  
  If intItemLength = "" Then
    intItemLength = 20
  End If
  
  If showLocation = "" Then
    showLocation = 0
  End If
  
  If showDateTime = "" Then
    showDateTime = 0
  End if
 
  If SkinDocked = "" Then
    SkinDocked = "DefaultDocked2"
  End if
 
  If SkinUnDocked = "" Then
    SkinUnDocked = "DefaultUndocked"
  End If
  
  If showImportantMailNr = "" Then
    showImportantMailNr = 0
  End if
   
  If cntSubFolder = "" Then
    cntSubFolder = 0
  Else 
    cntSubFolder = 0
  End if 
  
  checkstate
  MailboxInfo
  CalendarInfo
  TaskInfo

End Sub

'------------------------------------------------------------------------------------------------------------------------------
' Sub to read mail folder
' Returns the total number of mail and the number of unread mail and nr of important mail
'------------------------------------------------------------------------------------------------------------------------------
Sub MailboxInfo
  If doso = 1 Then
  On Error Resume Next
    a                   = System.Gadget.Settings.read("Mailbox1")
    b                   = System.Gadget.Settings.read("Mailbox2")
    cntSubFolder        = CInt(System.Gadget.Settings.read("cntSubFolder"))
    showImportantMailNr = CInt(System.Gadget.Settings.read("showImportantMailNr"))
    useSearchFolder     = System.Gadget.Settings.read("useSearchFolder")
  
    If txtUnreadtext = "" Then
      txtUnread = "Unread"
    Else
      txtUnread = txtUnreadtext
    End if 
  
    If useSearchFolder = "" Then
      useSearchFolder = 0
    End If

    If (a <> "") And (b <> "") Then                                            'Set Mailbox
      If useSearchFolder = 1 Then 
        Set olApp          = CreateObject("Outlook.Application")
        Set colStores      = olApp.Session.Stores
        Set oSearchFolders = colStores(a).GetSearchFolders
      
        intItems = oSearchFolders(b).Items.Count
        a = oSearchFolders(b).Folderpath
        i=1
        While i >0 
          i = InStr (a, "\")
          a = right (a, Len(a)-i)
        Wend 
        lblInbox.innerText = a & ": " & intItems
      Else
        Set objMailItems = objOutlook.Folders(a).Folders(b).Items
        Set objMail = objOutlook.Folders(a).Folders(b)
        If Err.Number > 0 Then                                                 'solve lost object issue
          SetOutlookObject
        
          Set objMailItems = objOutlook.Folders(a).Folders(b).Items
          Set objMail      = objOutlook.Folders(a).Folders(b)
          nrErrors = nrErrors + 1
          Err.Clear 
        End If
      End If  'useSearchFolder = 1
    Else
      Set objMailItems = objOutlook.GetDefaultFolder(6).Items	
      Set objMail = objOutlook.GetDefaultFolder(6)
      If Err.Number > 0 Then                                                   'solve lost object issue
        SetOutlookObject
      
        Set objMailItems = objOutlook.GetDefaultFolder(6).Items	
        Set objMail      = objOutlook.GetDefaultFolder(6)
        nrErrors = nrErrors + 1
        Err.Clear 
      End If
      If useSearchFolder = 1 Then
        intMUnread         = objMail.UnReadItemCount
        intMTotal          = objMail.Items.Count
        lblInbox.innerText = "" & intMTotal  & ","& txtUnread &": " & intMUnread
      End If 
    End If '(a <> "") And (b <> "")                                            'End Set Mailbox

    If useSearchFolder = 0 Then    
      objMailItems.Sort "[ReceivedTime]", True
      intMUnread     = 0
      intMTotal      = 0 
      intImportance  = 0
      countSubfolder = 1
      
      If showImportantMailNr = 0 Then
        intMUnread    = objMail.UnReadItemCount
        intMTotal     = objMail.Items.Count
        intImportance = 0
      Else
        For i = 1 To objMailItems.Count
          If objMailItems(i).Unread = True Then 
            intMUnread = intMUnread + 1
   		    If objMailItems(i).Importance = 2 Then 
   		      intImportance = intImportance + 1
            End If 
          End If 
          intMTotal = intMTotal + 1
        Next
      End If  
  
     ' Count items in subfolders (MAX 2 levels deep)
      If cntSubFolder = 1 Then 
        For i=1 To objMail.Folders.Count
          For j=1 To objMail.Folders(i).Folders.Count
            intMUnread = intMUnread + objMail.Folders(i).Folders(j).UnReadItemCount
            intMTotal  = intMTotal  + objMail.Folders(i).Folders(j).Items.Count
          Next
          intMUnread = intMUnread + objMail.Folders(i).UnReadItemCount
          intMTotal  = intMTotal  + objMail.Folders(i).Items.Count
        Next
      End If 'cntSubFolder = 1
  
      If intMUnread <> nrOfMail Then                       ' New Mail trigger. only if nr mail changed
        If intMUnread > nrOfMail Then               
          imgNM.src = NewMailIcon
        Else
          imgNM.src = InboxIcon
        End If 
      End If 'intMUnread <> nrOfMail
      
      nrOfMail = intMUnread
   
      If showImportantMailNr = 0 Then
        lblInbox.innerText = "" & intMTotal & ", "& txtUnread &": " & intMUnread
      Else
        lblInbox.innerText = "" & intMTotal & ", "& txtUnread &": " & intMUnread & ", " & intImportance & "!"
      End If 'showImportantMailNr = 0

    End If 
  
    If Err.Number>0 Then
      lblInbox.innerText = "Error: See FAQ in help-file" & Err.Description'"Error retrieving info..."
      nrOfMail = 9999                                      'if temp hik-up in outlook, this is to kill trigger new mail
    End If
     
  End If   
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' Sub to read appointments
' Returns the upcomming Appointments
'------------------------------------------------------------------------------------------------------------------------------
Sub CalendarInfo
On Error Resume Next
  
  If doso = 1 Then
    nrCalendarLines=0
    a            		= System.Gadget.Settings.read("Calendarbox1")
    b            		= System.Gadget.Settings.read("Calendarbox2")
    showLocation 		= System.Gadget.Settings.read("showLoc")
    showDateTime 		= System.Gadget.Settings.read("showDT")
    nrOfCharsToSkip 	= System.Gadget.Settings.read("nrCharSkip")
    nrOfCalenderItemsToShow = System.Gadget.Settings.read("nrCal")
    CharSkipDir       = System.Gadget.Settings.read("CharSkipDir")

    If nrOfCalenderItemsToShow = "" Then 
      nrOfCalenderItemsToShow = 3
    End If
  
    If showLocation = "" Then 
      showLocation = 0
    End If
  
    If showDateTime = "" Then 
      showDateTime = 0
    End If  
  
    If CharSkipDir = "" Then 
      CharSkipDir = 0
    End If
  
    If txtNoApptToday = "" Then
      txtNoApptToday = "No appointments today"
    Else
      txtNoApptToday = txtNoApptToday
    End If
   
    If (a <> "") And (b <> "") Then
      Set objCalItems = objOutlook.Folders(a).Folders(b).Items
      If Err.Number > 0 Then                                                   'solve lost object issue
        SetOutlookObject
        Set objCalItems = objOutlook.Folders(a).Folders(b).Items
        Err.Clear 
      End if
    Else
      Set objCalItems  = objOutlook.GetDefaultFolder(9).Items
      If Err.Number > 0 Then                                                   'solve lost object issue
        SetOutlookObject
        Set objCalItems = objOutlook.GetDefaultFolder(9).Items
        Err.Clear 
      End if
    End If
   
    If Err.Number > 0 Then                                                     'solve lost object issue
      SetOutlookObject
      Set objCalItems = objOutlook.GetDefaultFolder(9).Items
      Err.Clear 
    End if
  
    objCalItems.Sort "[Start]", False
    objCalItems.IncludeRecurrences = True

    datestart = CDate(Date-1)			
    dateend   = CDate(Date+90)

    p = "[Start] >= '" & datestart & "' and [Start] <= '" & dateend & "'"
    Set objCalItems = objCalItems.Restrict(p)	

    txt    = ""
    txtD   = ""
    MyDate = Now 
    nr     = 0                                                                 'number of appointments

    txtBU = lblCalendar.innerText                                              'in case of hik-up use previous value
   
    If objCalItems.Count > 30 Then                                             'Something buggy with Count property :-(
      nrStop = 30                                                              'hope to remove this in further release
    Else
      nrStop = objCalItems.Count
    End If
    apToday=0

    For i = 1 To nrStop 
      Set MyItem = objCalItems (i)
       If Err.Number = 0 Then                                                  'not perfect but keeps it rollin'                     
        If (DateDiff("n", MyDate, MyItem.End) >= 0) Then
          If nr < nrOfCalenderItemsToShow Then
            If (DateDiff("d", MyDate, MyItem.Start) <= 0) Then                 'Test if app. is today
              If MyItem.AllDayEvent = true Then
                If showDateTime = 1 Then 
	              txtPrefix = "All Day) "
                Else
                  txtPrefix = "* "
                End If
                txt2 = txtPrefix & MyItem.Subject                              'Today -> Show All day
                txtD = txtD & vbCrLf
                nrCalendarLines = nrCalendarLines + 1
              Else
                apToday=1
                If showDateTime = 1 Then 
	              txtPrefix = FormatDateTime(MyItem.Start,3) 
	              txtPrefix = Replace(txtPrefix, ":00 ", " ") & ") "           'cosmetic changes
	              txtPrefix = Replace(txtPrefix, ":00) ", ") ") 
                Else
                  txtPrefix = "* "
                End If
                txt2 = txtPrefix  & MyItem.Subject                             'Today -> Show time
                txtD = txtD & vbCrLf
                nrCalendarLines = nrCalendarLines + 1
              End If
            Else                                                               'App. is not today
              If apToday = 0 Then
                ta = txtNoApptToday & vbCrLf
                txtD = txtD & vbCrLf
                nrCalendarLines = nrCalendarLines + 1
                apToday =1
               End if
              If showDateTime = 1 Then 
	            txtPrefix = FormatDateTime(MyItem.Start,2) 
	            l = Len(txtPrefix)
	            If CharSkipDir = 1 then
	              txtPrefix = Right(txtPrefix,l-nrOfCharsToSkip) & ") "
	            Else
	              txtPrefix = Left(txtPrefix,l-nrOfCharsToSkip) & ") "
  	          End if
              Else
                txtPrefix = "* "
              End If          
              txt2 = txtPrefix & MyItem.Subject                                'Show date
              txtD = txtD & vbCrLf
              nrCalendarLines = nrCalendarLines + 1
            End If 
            txt2 = trimLine(txt2) 
            If (showLocation = 1) And (MyItem.Location <> "") Then
              txt2 = txt2 & vbCrLf
              txt2 = txt2 '& trimLine(MyItem.Location)                         'Show Location
              txtD = txtD & trimLine(MyItem.Location) 
              txtD = txtD & vbCrLf
              nrCalendarLines = nrCalendarLines + 1
            End If
            txt = ta & txt & txt2 & vbCrLf

            txt2 = ""
            ta = ""
          End If
          nr = nr + 1
        End If
      End If
    Next
  
    If txt = "" Then 
      lblCalendar.innerText = txtBU
      lblCalendar2.innerText = ""
    Else
      lblCalendar.innerText = txt
      lblCalendar2.innerText = txtD                        'put the text on gadget
    End If 

    If Err.Number>0 Then
    '  lblCalendar.innerText = "Error retrieving info..." & Err.Description
    End If 
  
  Else
    nrCalendarLines = 2                                                          
  End If
  
  tmp = imgNM.src                                          'save new mail icon (if appl)
  ReadSkin(Skin)                                           'resize if nesc.
  imgNM.src = tmp                                          'put back new mail icon 
   
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' Read tasks
' Return the non-finished tasks
'------------------------------------------------------------------------------------------------------------------------------
Sub TaskInfo
On Error Resume Next
  If doso = 1 Then
    taskCategory      = System.Gadget.Settings.read("tskFilter")
    taskImportance    = System.Gadget.Settings.read("tskImportance")
    CharSkipDir       = System.Gadget.Settings.read("CharSkipDir")
    nrOfCharsToSkip 	= System.Gadget.Settings.read("nrCharSkip")
    showDateTime 		= System.Gadget.Settings.read("showDT")
  
    If taskCategory = "-" Then
      taskCategory = ""
    End If 
  
    If showDateTime = "" Then 
      showDateTime = 0
    End If
 
    If nrOfCharsToSkip = "" Then 
      nrOfCharsToSkip = 0
    End If
  
    If CharSkipDir = "" Then 
      CharSkipDir = 0
    End If
  
    nrTaskLines = 0
    f = "@SQL=(""http://schemas.microsoft.com/mapi/id/{00062003-0000-0000-C000-000000000046}/810f0040"" IS NULL AND ""http://schemas.microsoft.com/mapi/proptag/0x10910040"" IS NULL)"

    
    Set wshShell = CreateObject("WScript.Shell")                               'Workaround to show tasks also with outlook 2003
    value = wshShell.RegRead("HKEY_CLASSES_ROOT\Outlook.Application\CurVer\")
  
    If value <> "Outlook.Application.11" then
      Set objTaskItems = objOutlook.GetDefaultFolder(28).Items.Restrict(f)     'todo folder (2007 & 2010)
    Else
      Set objTaskItems = objOutlook.GetDefaultFolder(13).Items.Restrict(f)     'tasks folder (2003)
    End If
  
    Set wshShell = nothing
  
    If Err.Number > 0 Then                                                     'solve lost object issue
      SetOutlookObject
      Set objTaskItems = objOutlook.GetDefaultFolder(28).Items.Restrict(f)
	  Err.Clear 
    End if
  
    objTaskItems.Sort "[DueDate]", False
    objTaskItems.IncludeRecurrences = True

    nr = 0 'number of tasks 
  
    If taskImportance = "" Then 
      taskImportance ="3"
    End If
  
    If taskCategory = "" Then 
      taskCategory ="3"
    End If

    cnt = objTaskItems.Count

    For i = 1 To objTaskItems.Count
      If Not objTaskItems(i).Complete Then 
        If (taskCategory = "3") Or (objTaskItems(i).Categories = taskCategory) then
          If taskImportance = "3" Or objTaskItems(i).Importance = taskImportance Then
            If nr < nrOfTaskItemsToShow Then
              txt2 =  objTaskItems(i).Subject 
              txt2 = trimLine(txt2) 
              If showDateTime = 1 Then 
	            txtd =  FormatDateTime(objTaskItems(i).DueDate, 2)
	            If txtd ="" Then
	              txtd  = FormatDateTime(objTaskItems(i).TaskDueDate)
	            End if
	            l = Len(txtd)
	            If CharSkipDir = 1 then
	              txtd = Right(txtd,l-nrOfCharsToSkip) & ") "
	            Else
	              txtd = Left(txtd,l-nrOfCharsToSkip) & ") "
	            End if
              Else
                txtd = "* "
              End If 
              txt = txt & " " & txtd & " " & txt2 & vbCrLf 'add prefix and linefeed
              nr = nr + 1
              nrTaskLines = nrTaskLines + 1
             End if
           End if
         End If
      End If
    Next

    lblTasks.innerText = txt
    
    If nrOfTaskItemsToShow > 0 Then 
      lblNrtasks.innerText = " (" & cnt & ")"
    End If

    If Err.Number>0 Then
    '  lblTasks.innerText = "Error retrieving info..."
    End If 
  Else
    nrTaskLines = 1    
  End If
  
  tmp = imgNM.src                                                         'save new mail icon (if appl)
  ReadSkin(Skin)                                                          'resize if nesc.
  imgNM.src = tmp                                                         'put back new mail icon 
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' reset new mail icon after click on mail icon
'------------------------------------------------------------------------------------------------------------------------------
Sub resetInboxIcon
  imgNM.src = InboxIcon
End sub

'------------------------------------------------------------------------------------------------------------------------------
' Read Skin and transform gadget
'------------------------------------------------------------------------------------------------------------------------------
Sub ReadSkin(Skin)
On Error Resume next
Dim objXML
  set objXML = CreateObject("Microsoft.XMLDOM")
  objXML.async = false
  If Skin = "" Then Skin = "DefaultDocked"
  f = gadgetPath+"\Skins\" & Skin & "\Skin.xml"
  
  Set file_obj = CreateObject("Scripting.FileSystemObject")  
  If (file_obj.FileExists(f)) Then
    Set file_path = file_obj.GetFile(f) 
    Set file = file_path.OpenAsTextStream (1, -2) 
    xmlResult = file.readall
    objXML.loadXML(xmlResult)
    file.Close 
    Set file_path = nothing 
    Set file_obj  = Nothing
   
    'Set properties of the gadget objects
    'Background
    BG.src                       = objXML.getElementsByTagName("BackgroundimageTasksSRC").item(0).text  
    BG.style.width               = objXML.getElementsByTagName("BackgroundimageTasksSRCWidth").item(0).text
    BG.style.height              = objXML.getElementsByTagName("BackgroundimageTasksSRCHeight").item(0).text
    document.body.style.width    = objXML.getElementsByTagName("BackgroundimageTasksSRCWidth").item(0).text
    document.body.style.height   = objXML.getElementsByTagName("BackgroundimageTasksSRCHeight").item(0).text -1
    'Gadget Title
    lblOI.innerText              = objXML.getElementsByTagName("GadgetTitleText").item(0).text
    lblOI.style.color            = objXML.getElementsByTagName("GadgetTitleColor").item(0).text
    lblOI.style.top              = objXML.getElementsByTagName("GadgetTitleTop").item(0).text
    lblOI.style.left             = objXML.getElementsByTagName("GadgetTitleLeft").item(0).text
    lblOI.style.fontfamily       = objXML.getElementsByTagName("GadgetTitleFont").item(0).text
    lblOI.style.fontSize         = objXML.getElementsByTagName("GadgetTitleFontSize").item(0).text
    lblOI.style.fontWeight       = objXML.getElementsByTagName("GadgetTitleFontWeight").item(0).text
   
    'Inbox
    imgNM.src                    = objXML.getElementsByTagName("InboxIconSRC").item(0).text
    imgNM.style.top              = objXML.getElementsByTagName("InboxIconTop").item(0).text
    imgNM.style.left             = objXML.getElementsByTagName("InboxIconLeft").item(0).text
    NewMailIcon                  = objXML.getElementsByTagName("InboxIconNewMailSRC").item(0).text
    InboxIcon                    = objXML.getElementsByTagName("InboxIconSRC").item(0).text
    txtInbox.innerText           = objXML.getElementsByTagName("InboxTitleText").item(0).text
    txtInbox.style.top           = objXML.getElementsByTagName("InboxTitleTop").item(0).text
    txtInbox.style.left          = objXML.getElementsByTagName("InboxTitleLeft").item(0).text
    txtInbox.style.color         = objXML.getElementsByTagName("InboxTitleColor").item(0).text
    txtInbox.style.fontfamily    = objXML.getElementsByTagName("InboxTitleFont").item(0).text
    txtInbox.style.fontSize      = objXML.getElementsByTagName("InboxTitleFontSize").item(0).text
    txtInbox.style.fontWeight    = objXML.getElementsByTagName("InboxTitleFontWeight").item(0).text
  
    lblInbox.style.top	         = objXML.getElementsByTagName("InboxTextTop").item(0).text
    lblInbox.style.left          = objXML.getElementsByTagName("InboxTextLeft").item(0).text
    lblInbox.style.color	     = objXML.getElementsByTagName("InboxTextColor").item(0).text
    lblInbox.style.fontfamily	 = objXML.getElementsByTagName("InboxFont").item(0).text
    lblInbox.style.fontSize	     = objXML.getElementsByTagName("InboxFontSize").item(0).text
    lblInbox.style.fontWeight	 = objXML.getElementsByTagName("InboxFontWeight").item(0).text
  
    'Calendar
    imgCA.src                    = objXML.getElementsByTagName("CalendarIconSRC").item(0).text
    imgCA.style.top              = objXML.getElementsByTagName("CalendarIconTop").item(0).text
    imgCA.style.left             = objXML.getElementsByTagName("CalendarIconLeft").item(0).text
    txtCalendar.innerText        = objXML.getElementsByTagName("CalendarTitleText").item(0).text
    txtCalendar.style.top        = objXML.getElementsByTagName("CalendarTitleTop").item(0).text
    txtCalendar.style.left       = objXML.getElementsByTagName("CalendarTitleLeft").item(0).text
    txtCalendar.style.color      = objXML.getElementsByTagName("CalendarTitleColor").item(0).text
    txtCalendar.style.fontfamily = objXML.getElementsByTagName("CalendarTitleFont").item(0).text
    txtCalendar.style.fontSize   = objXML.getElementsByTagName("CalendarTitleFontSize").item(0).text
    txtCalendar.style.fontWeight = objXML.getElementsByTagName("CalendarTitleFontWeight").item(0).text
  
    lblCalendar.style.top        = objXML.getElementsByTagName("CalendarTextTop").item(0).text
    lblCalendar.style.left       = objXML.getElementsByTagName("CalendarTextLeft").item(0).text
    lblCalendar.style.color      = objXML.getElementsByTagName("CalendarTextColor").item(0).text
    lblCalendar.style.fontfamily = objXML.getElementsByTagName("CalendarTextFont").item(0).text
    lblCalendar.style.fontSize   = objXML.getElementsByTagName("CalendarTextFontSize").item(0).text
    lblCalendar.style.fontWeight = objXML.getElementsByTagName("CalendarTextFontWeight").item(0).text
    
    lblCalendar2.style.top        = objXML.getElementsByTagName("CalendarTextTop").item(0).text
    lblCalendar2.style.left       = objXML.getElementsByTagName("CalendarTextLeft").item(0).text
    lblCalendar2.style.color      = objXML.getElementsByTagName("CalendarTextColor").item(0).text
    lblCalendar2.style.fontfamily = objXML.getElementsByTagName("CalendarTextFont").item(0).text
    lblCalendar2.style.fontSize   = objXML.getElementsByTagName("CalendarTextFontSize").item(0).text
   ' lblCalendar2.style.fontWeight = "Bold"
    lblCalendar2.style.fontstyle = "Italic"
  
    'Tasks
    imgTA.src                    = objXML.getElementsByTagName("TasksIconSRC").item(0).text
    imgTA.style.top              = objXML.getElementsByTagName("TasksIconTop").item(0).text
    imgTA.style.left             = objXML.getElementsByTagName("TasksIconLeft").item(0).text
    txtTasks.innerText           = objXML.getElementsByTagName("TasksTitleText").item(0).text
    txtTasks.style.top           = objXML.getElementsByTagName("TasksTitleTop").item(0).text
    txtTasks.style.left          = objXML.getElementsByTagName("TasksTitleLeft").item(0).text
    txtTasks.style.color         = objXML.getElementsByTagName("TasksTitleColor").item(0).text
    txtTasks.style.fontfamily    = objXML.getElementsByTagName("TasksTitleFont").item(0).text
    txtTasks.style.fontSize      = objXML.getElementsByTagName("TasksTitleFontSize").item(0).text
    txtTasks.style.fontWeight    = objXML.getElementsByTagName("TasksTitleFontWeight").item(0).text
  
    lblNrtasks.style.top         = objXML.getElementsByTagName("TasksNrTop").item(0).text
    lblNrtasks.style.left        = objXML.getElementsByTagName("TasksNrLeft").item(0).text
    lblNrtasks.style.color       = objXML.getElementsByTagName("TasksNrColor").item(0).text
    lblNrtasks.style.fontfamily  = objXML.getElementsByTagName("TasksNrFont").item(0).text
    lblNrtasks.style.fontSize    = objXML.getElementsByTagName("TasksNrFontSize").item(0).text
    lblNrtasks.style.fontWeight  = objXML.getElementsByTagName("TasksNrFontWeight").item(0).text
  
    lblTasks.style.top           = objXML.getElementsByTagName("TasksTextTop").item(0).text
    lblTasks.style.left	         = objXML.getElementsByTagName("TasksTextLeft").item(0).text
    lblTasks.style.color	     = objXML.getElementsByTagName("TasksTextColor").item(0).text
    lblTasks.style.fontfamily	 = objXML.getElementsByTagName("TasksTextFont").item(0).text
    lblTasks.style.fontSize 	 = objXML.getElementsByTagName("TasksTextFontSize").item(0).text
    lblTasks.style.fontWeight	 = objXML.getElementsByTagName("TasksTextFontWeight").item(0).text

    imgTitle.src        ="..\Skins\WindowsMobile6\Empty.png"
    imgMail.src         ="..\Skins\WindowsMobile6\Empty.png"
    imgSeperator1.src   ="..\Skins\WindowsMobile6\Empty.png"
    imgCalendar.src     ="..\Skins\WindowsMobile6\Empty.png"
    imgSeperator2.src   ="..\Skins\WindowsMobile6\Empty.png"
    imgTasks.src        ="..\Skins\WindowsMobile6\Empty.png"  
    imgBottom.src        ="..\Skins\WindowsMobile6\Empty.png"  

'------------------- dynamic resizing part ------------------------------------------------------------------------------------  
    v = objXML.getElementsByTagName("oixml-version").item(0).text
    If v="1.1" Or v="1.2" Or v="1.3" Then
      'Set heights ------------------------------------------------------------------------------------------------------------
      intHeightTitle             = CInt(objXML.getElementsByTagName("intHeightTitle").item(0).text)
      intHeightMail              = CInt(objXML.getElementsByTagName("intHeightMail").item(0).text)
      intHeightSeperator1        = CInt(objXML.getElementsByTagName("intHeightSeperator1").item(0).text)
      intHeightSeperator2        = CInt(objXML.getElementsByTagName("intHeightSeperator2").item(0).text)
      intHeightStartCalendar     = intHeightTitle + intHeightMail + intHeightSeperator1
      gwidth                     = objXML.getElementsByTagName("gwidth").item(0).text
    
      'Set image sources ------------------------------------------------------------------------------------------------------
      BG.src                     = "..\Skins\WindowsMobile6\Empty.png"
      imgMail.src                = objXML.getElementsByTagName("imgMail").item(0).text

    	imgSeperator1.src          = objXML.getElementsByTagName("imgSeperator1").item(0).text
    	imgCalendar.src            = objXML.getElementsByTagName("imgCalendar").item(0).text
    	imgSeperator2.src          = objXML.getElementsByTagName("imgSeperator2").item(0).text
    	imgTasks.src               = objXML.getElementsByTagName("imgTasks").item(0).text
    	imgTitle.src               = objXML.getElementsByTagName("imgTitle").item(0).text
    	
      'Set multipliers (shift pixels per line) --------------------------------------------------------------------------------
      multiplierCalendar         = objXML.getElementsByTagName("multipliercalendar").item(0).text
      multiplierTasks            = objXML.getElementsByTagName("multipliertasks").item(0).text
      
      'Set Offsets (shift one time x pixels because of title calendar and tasks) ----------------------------------------------
      intOffsetcalendar          = CInt(objXML.getElementsByTagName("offsetcalendar").item(0).text) + 1
      intOffsetcalendartitle     = CInt(objXML.getElementsByTagName("offsetcalendartitle").item(0).text)
      intOffsettasks             = CInt(objXML.getElementsByTagName("offsettasks").item(0).text) 
      intOffsettaskstitle        = CInt(objXML.getElementsByTagName("offsettaskstitle").item(0).text)
      
      'determine offsets ------------------------------------------------------------------------------------------------------
      offsetCalendar             = intOffsetcalendar + nrCalendarLines * multiplierCalendar
      offsetTasks                = intOffsettasks + nrTaskLines * multipliertasks
      
      'Place Title background -------------------------------------------------------------------------------------------------
      imgTitle.style.top         = 0
      imgTitle.style.width       = gwidth
      imgTitle.style.height      = objXML.getElementsByTagName("intHeightTitle").item(0).text
    
      
      'Place Mail background --------------------------------------------------------------------------------------------------
      imgMail.style.top          = intHeightTitle
      imgMail.style.width        = gwidth
      imgMail.style.height       = objXML.getElementsByTagName("intHeightMail").item(0).text
      
      'Place seperator1 -------------------------------------------------------------------------------------------------------
      imgSeperator1.style.top    = intHeightTitle + intHeightMail
      imgSeperator1.style.width  = gwidth
      imgSeperator1.style.height = objXML.getElementsByTagName("intHeightSeperator1").item(0).text
      
      'Determine Calendar canvas and place image ------------------------------------------------------------------------------
      imgCalendar.style.height   = intOffsetcalendar + nrCalendarLines * multiplierCalendar
      imgCalendar.style.width    = gwidth
      imgCalendar.style.top      = intHeightTitle + intHeightMail + intHeightSeperator1
      
      'Place Seperator2 -------------------------------------------------------------------------------------------------------
      imgSeperator2.style.top    = intHeightStartCalendar + offsetCalendar
      imgSeperator2.style.width  = gwidth
      imgSeperator2.style.Height = objXML.getElementsByTagName("intHeightSeperator2").item(0).text
      
      
      'Place Task -------------------------------------------------------------------------------------------------------------
      imgTasks.style.top         = intHeightStartCalendar + offsetCalendar + intHeightSeperator2
      taskHeight                 = intOffsettasks + nrTaskLines * multiplierTasks
      imgTasks.style.height      = taskHeight
      imgTasks.style.width       = gwidth
      
      
      'Place Task items -------------------------------------------------------------------------------------------------------
      lblTasks.style.top         = intHeightStartCalendar + offsetCalendar + intOffsettasks + intHeightSeperator2 
      lblNrtasks.style.top       = intHeightStartCalendar + offsetCalendar + intHeightSeperator2 + intOffsettaskstitle
      txtTasks.style.top         = intHeightStartCalendar + offsetCalendar + intHeightSeperator2 + intOffsettaskstitle
      imgTA.style.top            = intHeightStartCalendar + offsetCalendar + intHeightSeperator2 + intOffsettaskstitle
      
      'Set body height --------------------------------------------------------------------------------------------------------
      document.body.style.height = intHeightStartCalendar + offsetCalendar + offsetTasks + intHeightSeperator2
      
    End If
    If v="1.2" Or v="1.3" Then
      txtUnreadtext              = objXML.getElementsByTagName("InboxUnreadText").item(0).text
      txtNoApptToday             = objXML.getElementsByTagName("CalendarTextNoApptToday").item(0).text
      'read path images      
      
      intHeightBottom            = CInt(objXML.getElementsByTagName("intHeightBottom").item(0).text)
      imgBottom.src              = objXML.getElementsByTagName("imgBottom").item(0).text
             
      imgBottom.style.top        = intHeightStartCalendar + offsetCalendar + intHeightSeperator2 + taskHeight 
      imgBottom.style.width      = gwidth
      imgBottom.style.height     = intHeightBottom
      document.body.style.height = intHeightStartCalendar + offsetCalendar + offsetTasks + intHeightSeperator2 + intHeightBottom 
    End If
    
    If v="1.3" Then
      intItemLength              = objXML.getElementsByTagName("CharsOnLine").item(0).text
    End If
    
  Else 'this case should not be possible anymore
    MsgBox("File not found!" & vbcrlf & "Check the location of the gadget. The path should end with: \Outlook.gadget" & vbCrLf & vbcrlf & "The complete path should look like this:"& vbCrLf & "C:\Users\<yourname>\AppData\Local\Microsoft\Windows Sidebar\Gadgets\Outlook.gadget")   
  end if
  
  If Err.Number>0 Then
    MsgBox ("Error in XML file.")
  End If
 
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' trim function
'------------------------------------------------------------------------------------------------------------------------------
Function trimLine(txtIn)
  intItemLength = ll()
	If Len(txtIn) > intItemLength + 3 Then 
	  trimLine = Left(txtIn, intItemLength) & "..."
	Else
	  trimLine = txtIn
	End If
End Function

'------------------------------------------------------------------------------------------------------------------------------
' get textsize/length depends on version
'------------------------------------------------------------------------------------------------------------------------------
Function ll()
Dim objXML
  set objXML = CreateObject("Microsoft.XMLDOM")
  objXML.async = false
  If Skin = "" Then Skin = "DefaultDocked"
  f = gadgetPath+"\Skins\" & Skin & "\Skin.xml"
  
  Set file_obj = CreateObject("Scripting.FileSystemObject")  
  If (file_obj.FileExists(f)) Then
    Set file_path = file_obj.GetFile(f) 
    Set file = file_path.OpenAsTextStream (1, -2) 
    xmlResult = file.readall
    objXML.loadXML(xmlResult)
    file.Close 
    Set file_path = nothing 
    Set file_obj  = Nothing
        
    v = objXML.getElementsByTagName("oixml-version").item(0).text
    
    If v="1.3" Then
      ll = objXML.getElementsByTagName("CharsOnLine").item(0).text
    Else
      ll = System.Gadget.Settings.read("itemLength")
    End If
  End If
End Function

'------------------------------------------------------------------------------------------------------------------------------
' Toggle Pause function 
'------------------------------------------------------------------------------------------------------------------------------
Sub doPause()
  If doso = 1 Then
	t = "The gadget is paused." & vbcrlf & "Doubleclick the gadget to resume"
	lblCalendar.innerText = t
	lblCalendar2.innerText = ""
	lblTasks.innerText = "- Paused -"
	lblInbox.innerText = "- Paused -"
	didit = 0
	doso = 0
	s = System.Gadget.Settings.write("pause", doso) 
	Set objApp       = Nothing
    Set objOutlook   = Nothing  
  Else
	doso = 1
    s = System.Gadget.Settings.write("pause", doso)  	
	checkstate

  End If
  ' trigger gadget to run with or without Outlook info and set correct size of gadget  
  MailboxInfo
  CalendarInfo
  TaskInfo
End Sub
'------------------------------------------------------------------------------------------------------------------------------


