'// ---------------------------------------------------------------------------------------------------------------------------
'// 
'// Kelly Daamen, daamen@hotmail.com
'// 
'// ---------------------------------------------------------------------------------------------------------------------------


'------------------------------------------------------------------------------------------------------------------------------
' start this when window is opened
'------------------------------------------------------------------------------------------------------------------------------
Sub Window_Onload
  init()
  skinfolders()
  mailboxComboBox()
  calendarComboBox()
  taskComboBox()
  getVersion()
End sub

'------------------------------------------------------------------------------------------------------------------------------
' Get list of the skins 
'------------------------------------------------------------------------------------------------------------------------------
Sub skinfolders()
  Set FSO = CreateObject("Scripting.FileSystemObject")

  SD = System.Gadget.Settings.read("SkinDocked")
  SU = System.Gadget.Settings.read("SkinUndocked")

  If SD = "" Then SD = "Windows7"
  If SU = "" Then SU = "Windows7small"

  f = gadgetPath+"\Skins"  
  
  Set Folder =  FSO.GetFolder(f)
  Set Sa     = document.getElementById("envVar6a")
  a = 1 
  For Each Subfolder in Folder.SubFolders
    If Subfolder.Name <> "" Then
      Set objOpt   = document.createElement("OPTION")
      objOpt.Value = Subfolder.Name				
      objOpt.Text  = Subfolder.Name
      Sa.add objOpt
      Set objOpt = Nothing
      If Subfolder.Name = SD then
        Sa.selectedIndex = a-1
      End if
      a = a + 1		
    End If
  Next

  Set Sb = document.getElementById("envVar6b")  
  a=1 
  For Each Subfolder in Folder.SubFolders
    If Subfolder.Name <> "" Then
      Set objOpt   = document.createElement("OPTION")
      objOpt.Value = Subfolder.Name				
      objOpt.Text  = Subfolder.Name
      Sb.add objOpt
      Set objOpt = Nothing
       If Subfolder.Name = SU then
            Sb.selectedIndex = a-1
      End if
      a = a + 1		
    End If
  Next
End Sub 

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox 1 with all mail-accounts
'------------------------------------------------------------------------------------------------------------------------------
Sub mailboxComboBox
  On Error Resume Next
  
  If useSearchFolder = 1 Then                              'Use Favorite/Search folders
    Set olApp     = CreateObject("Outlook.Application")
    Set colStores = olApp.Session.Stores
    Set MB1       = document.getElementById("envVar7a")
  
    For q = 1 to colStores.Count 
      If Trim(colStores(q).Displayname) <> "" Then 
        Set objOpt   = document.createElement("OPTION")
        objOpt.Value = q
        objOpt.Text  = colStores(q).Displayname
        MB1.add objOpt
        Set objOpt = Nothing
        a=a+1	
      End If
    Next    
  Else                                                     'Use standard folders
    Set objApp =  CreateObject("Outlook.Application")
    Set objOutlook = objApp.GetNameSpace("MAPI")
    Set MB1 = document.getElementById("envVar7a")

    For i=1 To objOutlook.Folders.Count
      If Trim(objOutlook.Folders(i).Name) <> "" Then 
        Set objOpt   = document.createElement("OPTION")
        objOpt.Value = objOutlook.Folders(i).Name
        objOpt.Text  = objOutlook.Folders(i).Name
        MB1.add objOpt
        Set objOpt = Nothing
        a=a+1	
      End If 
    Next
  
    a = System.Gadget.Settings.read("Mailbox1")            'to display current settings
    b = System.Gadget.Settings.read("Mailbox2")            'to display current settings
    useSearchFolder = System.Gadget.Settings.read("useSearchFolder")
    
    If useSearchFolder = 1 Then
      Set olApp          = CreateObject("Outlook.Application")
      Set colStores      = olApp.Session.Stores
      Set oSearchFolders = colStores(a).GetSearchFolders
      CM.innerText       = CM.innerText & "Folder: " & oSearchFolders(b).FolderPath 
    Else
      CM.innerText       = CM.innerText & "Current Mailbox: " & objOutlook.Folders(a).Name & ", " & objOutlook.Folders(a).Folders(b).Name 
    End If
  End if
End Sub 

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox2 when combobox1 has chosen
'------------------------------------------------------------------------------------------------------------------------------
Sub mailboxComboBox2()
  On Error Resume Next
  
  If envVar7a.value <> "" Then 
    For d = 1 To envVar7b.options.length + 1
  	  envVar7b.remove(0)
    Next
    
    If S.checked = True Then
      useSearchFolder = 1
    Else
      useSearchFolder = 0
    End if
    
    If useSearchFolder = 1 Then                            'Use Favorite/Search folders
      Set olApp     = CreateObject("Outlook.Application")
      Set colStores = olApp.Session.Stores
      Set MB1       = document.getElementById("envVar7b")
      Nr            = envVar7a.value
   
      Set oSearchFolders = colStores(Nr).GetSearchFolders
  
      For i = 1 To oSearchFolders.Count
        If Trim(oSearchFolders(i).FolderPath) <> "" Then 
          Set objOpt   = document.createElement("OPTION")
          objOpt.Value = i
          'a = Replace (oSearchFolders(i).FolderPath, "\\" & colStores(Nr).Displayname, "")
      a = oSearchFolders(i).Folderpath
      j = 1
      While j > 0 
        j = InStr (a, "\")
        a = right (a, Len(a)-j)
      Wend 
          objOpt.Text  = a
          MB1.add objOpt
          Set objOpt = Nothing
          MB1.selectedIndex = 1
          a = a + 1	
        End If 
      Next
      envVar7b.style.width="125px"
    Else
      Set objApp     = CreateObject("Outlook.Application")
      Set objOutlook = objApp.GetNameSpace("MAPI")
      Set MB1        = document.getElementById("envVar7b")
      Nr             = envVar7a.value
  
      For i=1 To objOutlook.Folders(Nr).Folders.Count
        If Trim(objOutlook.Folders(i).Name) <> "" Then 
          Set objOpt = document.createElement("OPTION")
          objOpt.Value = i
          objOpt.Text  = objOutlook.Folders(Nr).Folders(i)
          MB1.add objOpt
          Set objOpt = Nothing
          MB1.selectedIndex = 1
          a=a+1	
        End If 
      Next
      envVar7b.style.width="125px"
    End If
    envVar7a.style.width="120px"
  End If 
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox 3 
'------------------------------------------------------------------------------------------------------------------------------
Sub calendarComboBox
  On Error Resume Next
  
  Set objApp =  CreateObject("Outlook.Application")
  Set objOutlook = objApp.GetNameSpace("MAPI")
  Set MB1 = document.getElementById("envVar8a")

  For i=1 To objOutlook.Folders.Count
    If Trim(objOutlook.Folders(i).Name) <> "" Then 
      Set objOpt   = document.createElement("OPTION")
      objOpt.Value = objOutlook.Folders(i).Name
      objOpt.Text  = objOutlook.Folders(i).Name
      MB1.add objOpt
      Set objOpt = Nothing
      a=a+1	
    End If 
  Next
  
  a = System.Gadget.Settings.read("Calendarbox1")
  b = System.Gadget.Settings.read("Calendarbox2")

  CC.innerText = CC.innerText & "Current Calendar: " & objOutlook.Folders(a).Name & ", " & objOutlook.Folders(a).Folders(b).Name
End Sub 

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox4 when combobox 3 has chosen
'------------------------------------------------------------------------------------------------------------------------------
Sub calendarComboBox2()
  On Error Resume Next
  Set objApp     = CreateObject("Outlook.Application")
  Set objOutlook = objApp.GetNameSpace("MAPI")
  Set MB1        = document.getElementById("envVar8b")

  Nr = envVar8a.value

  For i=1 To objOutlook.Folders(Nr).Folders.Count
    If Trim(objOutlook.Folders(i).Name) <> "" Then 
      Set objOpt   = document.createElement("OPTION")
      objOpt.Value = i
      objOpt.Value = objOutlook.Folders(Nr).Folders(i)
      objOpt.Text  = objOutlook.Folders(Nr).Folders(i)
      MB1.add objOpt
      Set objOpt        = Nothing
      MB1.selectedIndex = 1
      a=a+1	
    End If 
  Next
  envVar8a.disabled    = True
  envVar8a.style.width = "120px"
End Sub

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox 5 Task filter
'------------------------------------------------------------------------------------------------------------------------------
Sub taskComboBox()
  On Error Resume Next
  
  Set objApp       = CreateObject("Outlook.Application")    
  Set objNameSpace = objApp.GetNamespace("MAPI")
  Set MB1          = document.getElementById("envVar9")
    
  If objApp.Categories.Count > 0 Then
    For Each objCategory In objNameSpace.Categories
      Set objOpt   = document.createElement("OPTION")
      objOpt.Value = objCategory.Name
      objOpt.Text  = objCategory.Name
      MB1.add objOpt
      Set objOpt = Nothing
    Next
  End If
  
  Set objCategory  = Nothing
  Set objNameSpace = Nothing
  
  a = System.Gadget.Settings.read("tskFilter")
  b = System.Gadget.Settings.read("tskImportance")
  
  If a = "" Then 
    a = "Show All" 
  End If

  If b = 0 Then 
    c = "Low" 
  End If 
 
  If b = 1 Then 
    c = "Normal" 
  End If
    
  If b = 2 Then 
    c = "High" 
  End If
 
  If b = 3 Or b = "" Then 
    c = "All" 
  End If

  TF.innerText = TF.innerText & "Current Filter: " & a & ", with Importance: " & c
  Set wshShell = CreateObject("WScript.Shell")
  value = wshShell.RegRead("HKEY_CLASSES_ROOT\Outlook.Application\CurVer\")
  
  If value <> "Outlook.Application.12" Then 
  If value <> "Outlook.Application.14" Then
    TF.innerText = "Taskfilter is only working with MS Outlook 2007/2010"
    TF.style.color = "Red"
    End if
  End If 
 
  Set wshShell = nothing
 End Sub 

'------------------------------------------------------------------------------------------------------------------------------
' fill combobox 5 Task filter
'------------------------------------------------------------------------------------------------------------------------------
Sub getVersion()
On Error Resume next
  Dim objXML
  set objXML = CreateObject("Microsoft.XMLDOM")
  objXML.async = false

  f = gadgetPath+"" & "\Gadget.xml"
  
  Set file_obj = CreateObject("Scripting.FileSystemObject")  
  If (file_obj.FileExists(f)) Then
    Set file_path = file_obj.GetFile(f) 
    Set file = file_path.OpenAsTextStream (1, -2) 
    xmlResult = file.readall
    objXML.loadXML(xmlResult)
    file.Close 
    Set file_path = nothing 
    Set file_obj  = Nothing
  End if

     version.innerText = "Current version:" & objXML.getElementsByTagName("version").item(0).text & " Click to check online"
   
  If Err.Number>0 Then
    MsgBox ("Error in XML file.")
  End If
End sub
'------------------------------------------------------------------------------------------------------------------------------